import processing.video.*;
import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;

import jetson.*;

Capture cam;
Kamera kamera;
PWM pwm;
int STUFEN = 50;
float anteilvorz=0.0f;
public void setup()
{
    
    cam = new Capture(this, 640, 480);
    kamera = new Kamera(cam);
    
    pwm = new PWM(STUFEN);
        
    size(640,480);
    frameRate(30);
}

int x=0;
float aalt=0.0f;
public void draw()
{
    background(0);
    //kamera.drawTestpixel();
    kamera.frischeBildAuf();
    int xsp = kamera.berechneSchwerpunkt();
    kamera.zeichneKamerabild(0,0);
    kamera.zeichneSchwerpunkt(0,0,xsp);
        
    stroke(0,0,255);
    line(width/2,0,width/2,height);

    //Aktivität der Motoren und Regelabweichung anzeigen:
    textSize(24.0f);
    fill(255);
    text("Regeldifferenz = "+anteilvorz,30,30);
    fill(255,0,0);
    text("PWM links  = "+pwm.plinks,30,90);
    fill(0,255,0);
    text("PWM rechts = "+pwm.prechts,width-160,90);
    
    
    //Motoren über Lage des Schwerpunkts ansteuern:
    float RAND = 10.0;
    if(xsp>width/RAND && xsp<width-RAND)
    {
          float anteil = (xsp-width/RAND)/(width-RAND); // 0..1
          anteilvorz = (anteil-0.5)*2.0; // -1..+1
          if(anteilvorz==0.0)
          {
              pwm.pwmLinks(STUFEN);
              pwm.pwmRechts(STUFEN);
          }
          else if(anteilvorz>0.0)
          {
              float u = (float)STUFEN/2 - 0.4f*(float)STUFEN*anteilvorz;
              pwm.pwmLinks(STUFEN/2);
              pwm.pwmRechts((int)round(u));
              aalt = anteilvorz;
          }
          else //if(anteilvorz<0.0)
          {
              float u = (float)STUFEN/2 - 0.4f*(float)STUFEN*(-anteilvorz);
              pwm.pwmLinks((int)round(u));              
              pwm.pwmRechts(STUFEN/2);
              aalt = anteilvorz;
          }
    }
    else if(aalt>0.0f)
    {
              pwm.pwmLinks(STUFEN/2);
              pwm.pwmRechts(STUFEN/4);
    }
    else if(aalt<0.0f)
    {
              pwm.pwmLinks(STUFEN/4);
              pwm.pwmRechts(STUFEN/2);
    }
    else
    {
         pwm.pwmLinks(0);
         pwm.pwmRechts(0);
    }
    x++;    
}
